
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>关于ASP.NET内存缓存你需要知道的10点 / iVAN</title>

    <meta name="description" content="关于ASP.NET内存缓存你需要知道的10点 缓存机制的主要目的是提高应用程序的性能.作为 ASP.NET 开发人员,你可能会意识到 ASP.NET Web 窗体以及 ASP.NET MVC 可以使用 Cache 对象缓存应用程序的数据.这通常被称为服务器端数据缓存,并且常作为框架的内置功能.虽然 ASP.NET Core 中并没有这样的 Cache 对象,但是你可以很容易地实现内存缓存.本文将向你说明如何实现. 在进一步阅读之前,你先创建一个基于 Web 应用程序项目模板的新的 ASP.NET Core 应用程序. 然后按照下面提到的步骤">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">关于ASP.NET内存缓存你需要知道的10点</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>缓存机制的主要目的是提高应用程序的性能。作为 ASP.NET 开发人员，你可能会意识到 ASP.NET Web 窗体以及 ASP.NET<br />
MVC 可以使用  Cache 对象缓存应用程序的数据。这通常被称为服务器端数据缓存，并且常作为框架的内置功能。虽然 ASP.NET Core<br />
中并没有这样的 Cache  对象，但是你可以很容易地实现内存缓存。本文将向你说明如何实现。</p>
<p>在进一步阅读之前，你先创建一个基于 Web 应用程序项目模板的新的 ASP.NET Core 应用程序。</p>
<p><a href="http://s4.51cto.com/wyfs02/M00/99/B2/wKioL1lLWnrAFs-oAABFKCHIZEI411.jpg-wh_651x-s_34928602.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczQuNTFjdG8uY29tL3d5ZnMwMi9NMDAvOTkvQjIvd0tpb0wxbExXbnJBRnMtb0FBQkZLQ0hJWkVJNDExLmpwZy13aF82NTF4LXNfMzQ5Mjg2MDIuanBn.jpg"></a></p>
<p>然后按照下面提到的步骤逐一构建和测试由内存缓存提供的各种功能。</p>
<p><strong>1. 内存缓存需要在启动类 Startup 中启用一下</strong></p>
<p>不同于 ASP.NET Web 窗体和 ASP.NET MVC，ASP.NET Core 没有内置的 Cache<br />
对象，可以拿来在控制器里面直接使用。  这里，内存缓存时通过依赖注入来启用的，因此第一步就是在 Startup<br />
类中注册内存缓存的服务。如此，就得打开 Startup 类然后定位到  ConfigureServices() 方法，像下面这样修改<br />
ConfigureServices() 方法:</p>
<pre>
</pre>
<ol>
<li>public void ConfigureServices(IServiceCollection services) </li>
<li> </li>
<li>{ </li>
<li> </li>
<li>    services.AddMvc(); </li>
<li> </li>
<li>        services.AddMemoryCache(); </li>
<li> </li>
<li>}  </li>
</ol>
<p>为了向你的应用程序加入内存缓存能力，你需要在服务集合上调用 AddMemoryCache() 方法。采用这种办法就可以让一个内存缓存(它是一个  IMemoryCache 对象)的默认实现可以被注入到控制器中去。</p>
<p><strong>2. 内存缓存使用依赖注入来注入缓存对象</strong></p>
<p>然后打开 HomeController 并对其进行修改，如下所示：</p>
<pre>
</pre>
<ol>
<li>public class HomeController : Controller </li>
<li> </li>
<li>{ </li>
<li> </li>
<li>    private IMemoryCache cache; </li>
<li> </li>
<li> </li>
<li>    public HomeController(IMemoryCache cache) </li>
<li> </li>
<li>    { </li>
<li> </li>
<li>        this.cache = cache; </li>
<li> </li>
<li>    } </li>
<li> </li>
<li>    .... </li>
<li> </li>
<li>}  </li>
</ol>
<p>如你所见，上述代码声明了一个 ImemoryCache 的私有变量。该变量会被构造器中被赋值。构造器会通过  DI(依赖注入)接收到缓存参数，然后被存储在本地变量总，提供后续使用。</p>
<p><strong>3. 你可以使用 Set() 方法来在缓存中存东西</strong></p>
<p>等你有了这个 IMemoryCache 对象，就可以读取或者向它写入数据了。向缓存写入数据项是相当直接的。</p>
<pre>
</pre>
<ol>
<li>public IActionResult Index() </li>
<li> </li>
<li>{ </li>
<li> </li>
<li>  cache.Set&lt;string&gt;("timestamp", DateTime.Now.ToString()); </li>
<li> </li>
<li>  return View(); </li>
<li> </li>
<li>}  </li>
</ol>
<p>上述代码在 Index() 这个 action 中设置了一个缓存项。这是通过使用 IMemoryCache 的<br />
Set&lt;T&gt;()  来完成的。Set()<br />
方法的第一个参数是键名，用来标识该数据项。第二个参数是键的取值。在此例中，我们存储一个字符串的键和一个字符串的值，而你也可以存储其它类型<br />
(原生以及自定义的类型) 的键值对。</p>
<p><strong>4. 你可以使用 Get 方法来从缓存中获取到一个数据项</strong></p>
<p>等你向缓存中添加好了数据，也许会想要在应用程序的其它地方去获取到该数据，可以用 Get() 来做到。如下代码会告诉你如何来做这件事情。</p>
<pre>
</pre>
<ol>
<li>public IActionResult Show() </li>
<li> </li>
<li>{ </li>
<li> </li>
<li>  string timestamp = cache.Get&lt;string&gt;("timestamp"); </li>
<li> </li>
<li>  return View("Show",timestamp); </li>
<li> </li>
<li>}  </li>
</ol>
<p>上述代码从 HomeController 的另外一个action(Show)那里获取到了一个缓存的数据项。Get()<br />
方法会指定数据项的类型以及它的键名。如果该数据项存在的话，就会被返回并且被赋值给 timestamp 这个字符串变量。然后这个<br />
timestamp  的值就会被传递给 Show 视图。</p>
<p>Show 视图只是简单地输出了 timestamp 的值，如下所示：</p>
<pre>
</pre>
<ol>
<li>&lt;h1&gt;TimeStamp : @Model&lt;/h1&gt; </li>
<li> </li>
<li> </li>
<li>&lt;h2&gt;@Html.ActionLink("Go back", "Index", "Home")&lt;/h2&gt;  </li>
</ol>
<p>为了对目前为止你所写的代码进行一下测试，请运行应用程序。首先将浏览器导航至 /Home/Index ，这样 timestamp<br />
键就会被赋值。然后导航至  /Home/Show 并查看 timestamp 值是否会输出。下图所示是 Show() 这个 action<br />
运行起来的一个例子。</p>
<p><a href="http://s5.51cto.com/wyfs02/M02/99/B2/wKioL1lLWuXxCnylAABBZovRgqY842.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczUuNTFjdG8uY29tL3d5ZnMwMi9NMDIvOTkvQjIvd0tpb0wxbExXdVh4Q255bEFBQkJab3ZSZ3FZODQyLmpwZw==.jpg"></a></p>
<p><strong>5. 你可以使用 TryGet() 来检查缓存中是否存在特定的键值</strong></p>
<p>如果你观察前面的示例，会发现每次你导航至 /Home/Index 的时候, 都会有一个新的 timestamp<br />
被赋值给了缓存项。这是因为我们并没有对此进行检查，规定只有在数据项不存在的时候才赋值。许多时候你都会想要这样做的。这里有两种办法可以在<br />
Index() 这个  action 里面来做这样的检查。我们把两种办法都在下面列了出来。</p>
<pre>
</pre>
<ol>
<li>//first way </li>
<li> </li>
<li>if (string.IsNullOrEmpty </li>
<li> </li>
<li>(cache.Get&lt;string&gt;("timestamp"))) </li>
<li> </li>
<li>{ </li>
<li> </li>
<li>  cache.Set&lt;string&gt;("timestamp", DateTime.Now.ToString()); </li>
<li> </li>
<li>} </li>
<li> </li>
<li> </li>
<li>//second way </li>
<li> </li>
<li>if (!cache.TryGetValue&lt;string&gt; </li>
<li> </li>
<li>("timestamp", out string timestamp)) </li>
<li> </li>
<li>{ </li>
<li> </li>
<li>    cache.Set&lt;string&gt;("timestamp", DateTime.Now.ToString()); </li>
<li> </li>
<li>}  </li>
</ol>
<p>第一种办法使用了你早先用过的同一个 Get() 方法，这一次它被拿来跟 if 块一起用。如果 Get()  不能在缓存中找到指定的数据项，IsNullOrEmpty() 就会返回 true。而只有这时候 Set() 才会被调用，一次来添加数据项。</p>
<p>第二种办法更加优雅一点。它使用 TryGet() 方法来获取一个数据项。TryGet()  方法会返回一个布尔值来指明数据项有没有被找到。实际的数据项可以使用一个输出参数拉取出来。如果 TryGet() 返回false，Set()  就会被用来添加数据。</p>
<p><strong>6. 如果不存在的话，可以使用 GetOrCreate() 来添加一项</strong></p>
<p>有时你需要从缓存中检索现有项。如果该项目不存在，则希望添加该项。这两个任务 - 如果它存在获取值，否则创建之 - 可以使用 GetOrCreate()  方法来实现。修改后的 Show() 方法展示了如何实现的。</p>
<pre>
</pre>
<ol>
<li>public IActionResult Show() </li>
<li> </li>
<li>{ </li>
<li> </li>
<li>  string timestamp = cache.GetOrCreate&lt;string&gt; </li>
<li> </li>
<li>  ("timestamp", entry =&gt; {  </li>
<li> </li>
<li>return DateTime.Now.ToString(); }); </li>
<li> </li>
<li>  return View("Show",timestamp); </li>
<li> </li>
<li>}  </li>
</ol>
<p>Show() 动作现在使用 GetOrCreate() 方法。 GetOrCreate()  方法将检查时间戳的键值是否存在。如果是，现有值将被赋值给局部变量。否则，将根据第二个参数中指定的逻辑创建一个新条目并将其添加到缓存中。</p>
<p>为了测试此代码，请直接运行 /Home/Show，不需要跳转到  /Home/Index。你仍然会看到输出的时间戳值，因为在该值不存在的情况下，GetOrCreate() 现在是添加了它。</p>
<p><strong>7. 你可以在一个缓存的数据项上面设置绝对和滚动的过期时间</strong></p>
<p>在前述示例中，一个缓存项只要被添加到缓存就会一直存储，除非它被明确地使用 Remove()<br />
从缓存中移除。你也可以在一个缓存项上面设置一个绝对和滚动的过期时间。一个绝对的过期设置意味着该缓存项会在严格指定的日期和时间点被移除，而滚动过期设置则意味着它在给定的一段时间量处于空闲状态(也就是没人去访问)之后被移除。</p>
<p>为了能在一个缓存项上面设置这两种过期策略，你要用到 MemoryCacheEntryOptions 对象。如下代码向你展示了如何去使用。</p>
<pre>
</pre>
<ol>
<li>MemoryCacheEntryOptions options =  </li>
<li> </li>
<li>new MemoryCacheEntryOptions(); </li>
<li> </li>
<li>options.AbsoluteExpiration =  </li>
<li> </li>
<li>DateTime.Now.AddMinutes(1); </li>
<li> </li>
<li>options.SlidingExpiration =  </li>
<li> </li>
<li>TimeSpan.FromMinutes(1); </li>
<li> </li>
<li>cache.Set&lt;string&gt;("timestamp",  </li>
<li> </li>
<li>DateTime.Now.ToString(), options);  </li>
</ol>
<p>上述代码来自于修改过的 Index() action，它创建了一个 MemoryCacheEntryOptions 的对象，然后将它的<br />
AbsoluteExpiration 属性设置为从此刻到一分钟之后的一个 DateTime 值，它还将 SlidingExpiration<br />
属性设置为一分钟。这些值都指定了该缓存项会在一分钟之后从缓存移除，不管其是否会被访问。此外，如果该缓存项如初持续空闲了有一分钟，它也会被从缓存中移除。</p>
<p>等你将 AbsoluteExpiration 和 SlidingExpiration 的值设置后， Set()<br />
方法就可以被用来将一个数据项添加到缓存。这一次 MemoryCacheEntryOptions 对象会被作为第三个参数传递给 Set() 方法。</p>
<p><strong>8. 当缓存项会被移除时，你可以连接回调</strong></p>
<p>有时你会想要在缓存项从缓存中被移除时收到通知。可能会有多种原因需要从缓存中移除数据项。例如，因为明确地执行了 Remove()<br />
方法而移除了一个缓存项,  也有可能是因为它的 AbsoluteExpiration 和 SlidingExpiration<br />
值已经到期而被移除，诸如此类的原因。</p>
<p>为了能知道项目是何时从缓存移除的，你需要编写一个缓存函数。如下代码向你展示了如何去做这件事情：</p>
<pre>
</pre>
<ol>
<li>MemoryCacheEntryOptions options = new MemoryCacheEntryOptions(); </li>
<li>options.AbsoluteExpiration =  </li>
<li>DateTime.Now.AddMinutes(1); </li>
<li>options.SlidingExpiration =  </li>
<li>TimeSpan.FromMinutes(1); </li>
<li>options.RegisterPostEvictionCallback </li>
<li>(MyCallback, this); </li>
<li>cache.Set&lt;string&gt;("timestamp",  </li>
<li>DateTime.Now.ToString(), options);  </li>
</ol>
<p>上述代码同之前使用 MemoryCacheEntryOptions 来配置 AbsoluteExpiration 和<br />
SlidingExpiration  的代码相当类似。更加重要的是它也调用了 RegisterPostEvictionCallback()<br />
方法来绑定刚刚讨论过的回调函数。在这里回调函数被命名为  MyCallback。第二个参数是一个你会想要传递给回调函数的状态对象。这里我们传入了<br />
 HomeController 的实例 (用 this 将当前的  HomeController 对象“点”出来) 作为状态对象。</p>
<p>前面提到的MyCallback函数，其代码如下所示：</p>
<pre>
</pre>
<ol>
<li>private static void MyCallback(object key, object value, </li>
<li> </li>
<li>EvictionReason reason, object state) </li>
<li> </li>
<li>{ </li>
<li> </li>
<li>    var message = $"Cache entry was removed : {reason}"; </li>
<li> </li>
<li>    ((HomeController)state). </li>
<li> </li>
<li>cache.Set("callbackMessage", message); </li>
<li> </li>
<li>}  </li>
</ol>
<p>请仔细观察这段代码。 MyCallback() 是 HomeController<br />
类里面的一个私有静态函数，它有四个参数。前面两个参数表示刚刚删除的缓存项的键和值，第三个参数表示的是该数据项被删除的原因。EvictionReason<br />
  是一个枚举类型，它维护者各种可能的删除原因，如过期，删除以及替换。</p>
<p>在回调函数的内部，我们会基于删除的原因构造一个字符串消息。我们想要将此消息设置成另外一个缓存项。这样做的话就需要访问<br />
HomeController  的缓存对象，此时状态参数就可以排上用场了。使用状态对象，你可以对 HomeController<br />
的缓存对象进行控制，并使用 Set() 增加一个  callbackMessage 缓存项。</p>
<p>你可以通过 Show() 这个 action 来访问到 callbackMessage，如下所示：</p>
<pre>
</pre>
<ol>
<li>public IActionResult Show(){ </li>
<li>  string timestamp = cache.Get&lt;string&gt;("timestamp"); </li>
<li>  ViewData["callbackMessage"] =  </li>
<li>    cache.Get&lt;string&gt;("callbackMessage"); </li>
<li>  return View("Show",timestamp); </li>
<li>}  </li>
</ol>
<p>最后就可以在 Show 视图中显示出来了：</p>
<pre>
</pre>
<ol>
<li>&lt;h1&gt;TimeStamp : @Model&lt;/h1&gt; </li>
<li> </li>
<li>&lt;h3&gt;@ViewData["callbackMessage"]&lt;/h3&gt; </li>
<li> </li>
<li>&lt;h2&gt;@Html.ActionLink("Go back", "Index", "Home")&lt;/h2&gt;  </li>
</ol>
<p>为了测试回调，我们需要运行应用程序并跳转到 /Home/Index。然后跳转到<br />
/Home/Show，并不停地刷新浏览器。在某些时间点，由于其  AbsoluteExpiration<br />
设置之后，时间戳项目将会过期。你会看到这样的 callbackMessage：</p>
<p><a href="http://s2.51cto.com/wyfs02/M02/99/B2/wKioL1lLW2mwq4IbAAA-LC-wIUw115.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczIuNTFjdG8uY29tL3d5ZnMwMi9NMDIvOTkvQjIvd0tpb0wxbExXMm13cTRJYkFBQS1MQy13SVV3MTE1LmpwZw==.jpg"></a></p>
<p><strong>9. 你可以设置缓存项的优先级</strong></p>
<p>正如你可以设置缓存项的到期策略一样，你还可以为缓存项赋予优先级。如果服务器内存紧缺的话，就会基于此优先级对缓存项进行清理以回收内存。  想要设置优先级的话，就要再一次用到 MemoryCacheEntryOptions。</p>
<pre>
</pre>
<ol>
<li>MemoryCacheEntryOptions options =  </li>
<li> </li>
<li>new MemoryCacheEntryOptions(); </li>
<li> </li>
<li>options.Priority = CacheItemPriority.Normal; </li>
<li> </li>
<li>cache.Set&lt;string&gt;("timestamp",  </li>
<li> </li>
<li>DateTime.Now.ToString(), options);  </li>
</ol>
<p>MemoryCacheEntryOptions 的 Priority 属性让你可以使用 CacheItemPriority  枚举来设置缓存项的优先级取值。可选的值有 Low，Normal，High 以及 NeverRemove。</p>
<p><strong>10. 你可以设置多个缓存项之间的依赖关系</strong></p>
<p>你还可以对一组缓存项目之间的依赖关系进行设置，例如在删除一个缓存项时，所有依赖的项也会被删除。 要是你想要了解它是如何工作的，可以像下面这样对  Index()这个 action 做一下修改：</p>
<pre>
</pre>
<ol>
<li>public IActionResult Index() </li>
<li> </li>
<li>{ </li>
<li> </li>
<li>    var cts = new CancellationTokenSource(); </li>
<li> </li>
<li>    cache.Set("cts", cts); </li>
<li> </li>
<li> </li>
<li>    MemoryCacheEntryOptions options =  </li>
<li> </li>
<li>new MemoryCacheEntryOptions(); </li>
<li> </li>
<li>    options.AddExpirationToken( </li>
<li> </li>
<li>new CancellationChangeToken(cts.Token)); </li>
<li> </li>
<li>    options.RegisterPostEvictionCallback </li>
<li> </li>
<li>(MyCallback, this); </li>
<li> </li>
<li>    cache.Set&lt;string&gt;("timestamp",  </li>
<li> </li>
<li>DateTime.Now.ToString(), options); </li>
<li> </li>
<li> </li>
<li>    cache.Set&lt;string&gt;("key1", "Hello World!",  </li>
<li> </li>
<li>new CancellationChangeToken(cts.Token)); </li>
<li> </li>
<li>    cache.Set&lt;string&gt;("key2", "Hello Universe!",  </li>
<li> </li>
<li>new CancellationChangeToken(cts.Token)); </li>
<li> </li>
<li> </li>
<li>    return View(); </li>
<li> </li>
<li>}  </li>
</ol>
<p>代码首先创建了一个 CancellationTokenSource 对象，该对象被存储为一个独立的缓存项 cts。然后像之前那样创建出<br />
MemoryCacheEntryOptions 对象。这时候调用 MemoryCacheEntryOptions 的<br />
AddExpirationToken()  方法来指定过期令牌。我们不会在这里探讨 CancellationChangeToken<br />
的细节。可以这样理解，过期令牌能让你有权利让一个缓存项过期。如果令牌处于活动状态的话，则缓存项就会在缓存中维持，而如果令牌被取消掉了，则该缓存项就将从缓存中删除掉。一旦缓存项从缓存中删除掉了，MyCallback<br />
  就像之前一样被调用。之后代码又创建了两个缓存项—— key1 和 key2。在添加这两个缓存项时，Set() 的第三个参数将基于之前所创建的<br />
 cts  对象传递一个 CancellationChangeToken。</p>
<p>这样做就意味着这里我们有了三个键 - timestamp 是主键，而 key1 和 key2 则依赖于 timestamp。当<br />
timestamp  被删除时，key1 和 key2 也应该被删除掉。要删除<br />
timestamp，你需要在代码中的某个地方取消其令牌。我们可以单独的一个  action(Remove())中进行这样的操作。</p>
<pre>
</pre>
<ol>
<li>public IActionResult Remove() </li>
<li> </li>
<li>{ </li>
<li> </li>
<li>    CancellationTokenSource cts =  </li>
<li> </li>
<li>cache.Get&lt;CancellationTokenSource&gt;("cts"); </li>
<li> </li>
<li>    cts.Cancel(); </li>
<li> </li>
<li>    return RedirectToAction("Show"); </li>
<li> </li>
<li>}  </li>
</ol>
<p>这里我们先获取到之前存储的 CancellationTokenSource 对象，并调用它的 Cancel() 方法。这样做会把<br />
timestamp，key1 以及 key2 都删除掉。 你可以通过在 Show() 这个 action<br />
中获取一下所有这三个键来确认它们是否已经被删除掉了。</p>
<p>为了测试这个例子，运行应用程序并导航至 /Home/Index。然后再导航至<br />
/Home/Show，并检查所有这三个键值是否按预期显示了出来。然后导航至  /Home/ Remove，浏览器将被重定向回<br />
/Home/Show。由于 Remove() 取消了令牌，所有的键都已经被删除调了，而现在 Show<br />
视图会将删除的原因(TokenExpired)显示出来，如下所示：</p>
<p><a href="http://s5.51cto.com/wyfs02/M02/99/B2/wKioL1lLW8uBMIJzAABAP1n8wh8922.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczUuNTFjdG8uY29tL3d5ZnMwMi9NMDIvOTkvQjIvd0tpb0wxbExXOHVCTUlKekFBQkFQMW44d2g4OTIyLmpwZw==.jpg"></a></p>
<p>到目前为止就是这些了!笔耕不辍!</p>
<p>作者：OSC-协作翻译</p>
<p>来源：51CTO</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-23 23:37:36</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/index/" title="index">index</a>, <a href="https://www.iamivan.net/tag/asp/" title="asp">asp</a>, <a href="https://www.iamivan.net/tag/cache/" title="Cache">Cache</a>, <a href="https://www.iamivan.net/tag/timestamp/" title="timestamp">timestamp</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>关于ASP.NET内存缓存你需要知道的10点的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z76mQdp.html" rel="bookmark">大规模运行MongoDB应该知道的10件事</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MongoDB MongoDB的首席解决方案架构师Asya Kamsky 最近发表了一篇文章,概括了大规模运行MongoDB需要知道的10件事. MongoDB也需要DevOps.MongoDB是一个数据库.和任何其他的数据存储一样,它也需要容量计划.调整.监控和维护.不要因为它很容易安装.入门,同时与关系型数据库相比能够更加自然地满足开发人员的范例就认为MongoDB不需要适当的照顾和喂养.开发时它能在小样本数据集上超快地运行并不意味着你就不需要良好的模式.索引策略以及产品环境所需要的正确的硬			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/rz4A18b.html" rel="bookmark">你应该知道的10件关于Java 6的事情</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;What's New in Java SE 6 Beta 2&gt;一文中描述了你应该知道的10件关于Java 6的事情,下面总结如下 1.Web Services. 优先支持编写 XML web service 客户端程序.你可以用过简单的annotaion将你的API发布成.NET交互的web services. Mustang 添加了新的解析和 XML 在 Java object-mapping APIs中, 之前只在Java EE平台实现或者Java Web Services Pack中提			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdR7Bxb.html" rel="bookmark">&lbrack;转载&rsqb; Flash开发者需要知道的10件事</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				来源:http://www.infoq.com/cn/news/2010/02/Flash-ten-things 此前,我们发布的新闻谈到了每个Flex开发者需要知道的10件事,本文将继续这个主题,谈谈每个Flash开发者需要知道的10件事. 近日John Lindquist谈到了在为Roundarch公司招聘Flash/Flex开发人员时的一些感受.他认为最难的地方在于问什么问题才能最好地了解到应聘者的Flash /Flex开发技能.因此,他给出了一个列表并说到:&quot;根据我的经验,通过这个列表能			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQBgoQM.html" rel="bookmark">&lbrack;转载&rsqb;一名优秀的Flex开发者需要知道的10样东西</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:http://blog.flexdevelopers.com/2010/04/10-things-good-flex-developer-should.html 翻译:http://bbs.9ria.com/viewthread.php?tid=54144&amp;from=recommend_f   要想成为一名优秀的Flex编程人员,单单知道怎么样去使用Flex内建的容器和组件是不够的,而且是远远不够. 下面是我对这个问题的一些看法......并且给出了一些资源和关键字,你可以通过Google			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXNOyjb.html" rel="bookmark">关于电子钱包需要知道的10件事</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1月15日消息,据http://www.aliyun.com/zixun/aggregation/16417.html&quot;&gt;BusinessInsider网站报道,移动支付和电子钱包正在进入我们的生活的各个方面,但是对于这一新生的事物,人们知道的并不清楚,以下为您盘点关于它需要知道的10件事: 1.在线支付领域的&quot;三巨头&quot; 少数几个公司已经在电子在线支付领域取得领先地位:谷歌.亚马逊和PayPal.现在他们在尝试进军日常生活业务了.谷歌钱包服务允许人们把钱存在手机中,然后			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmYaVBp.html" rel="bookmark">思科全球黄金认证 你需要知道的10件事</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				欢迎来到Cisco Global Gold! 多年来,思科正在为其合作伙伴计划(Cisco Global Gold)增加新的认证级别. 思科全球黄金认证 你需要知道的10件事 思科全球合作伙伴组织战略.规划与计划高级总监Marc Surplus表示:&quot;世界正在发生变化,支持全球客户变得越来越重要.随着软件作为思科产品组合的一部分逐渐成为常态化,我们开始推动企业协议(ELA),合作伙伴需要在整个客户生命周期中以一致的方式在全球范围内推动部署.&quot; 以下总结了思科渠道合作伙伴需要了解的关于新			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLmj1az.html" rel="bookmark">Flex中你最应该知道的10点</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 重新定义:Flex是web标准     MXML是Flex应用的标准语言,它允许开发人员开发应用程序架构,不仅包括表现层也包括class structure.这对web设计类的人和后台开发的人来说很容易,因为MXML markup与HTML很类似.同样的,Flex内的ActionScript与JavaScript也很有可比性,而且Flex使用web标准的CSS 来控制表现层.它也是构建应用架构的好方法,因为语言的树形特性使它很好地融合了一个典型的应用container-component			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrK4Wmp.html" rel="bookmark">每位网页设计师新手都应知道的10件事</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在做网站时会遇到很多的问题,所以网页设计师通常要扮演多种角色,并且要掌握如何构建一个有效实用的网站布局知识. 你在网页设计所学到的大多数教训都来自工作经验.学习是一个反复持续的过程,并且没有比犯错更好的方式来获得知识(从错误中学习).在本文中,我们将讨论10个重要并常规的技巧,这是每位网页设计师新手都应该知道. 1. 优化图片,获得更好的页面加载速度 学习如何通过选择正确的格式,来优化网页图片,并确保文件大小在可行的范围你是足够小的.虽然现在人们已经都在使用宽带,但仍然有人是拨号上网.此外, 虽			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9N26Xp.html" rel="bookmark">关于Docker你应该知道的10件事</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 如果你在企业IT工作,那你会听说过Docker.即使在是像Puppet.Hadoop和MongoDB这样的热门技术中,Docker也会脱颖而出. 但正是因为Docker正处于炒作期,因此这并不意味着它适合你.正如我们Tech  Pro Research分析中指出,&quot;不管你的公司是否给了Docker一个肯定的'可能',需要警惕.&quot; 但是,在你下载Docker并使用起来之前,有10件事情是你应该对这项超人气容器技术应该了解的. 1.Docker是一种打包和分发软件的方式 一个现代的软件系			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMl07OM.html" rel="bookmark" class="title">通过SEO工具做好网站排名</a>
					<div>
						一个网站的跳出率跟哪些因素有关呢?现在很多站长都很关注统计工具里面的数据,网站稍微有点风吹草动就会坐立不安,一个网站如果基础优化做的好,就不用担心没有用户,网站的首页也要有足够的吸引力,我们可以借助一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlyxqp.html" rel="bookmark" class="title">C&num;中除去所有在HTML元素中标记</a>
					<div>
						/// 除去所有在HTML元素中标记  public static string StripHTML(string strHtml)  {   string strOutput=strHtml;    ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeEV7z.html" rel="bookmark" class="title">SEO不是网络营销  只是辅助于SEM的一种方式</a>
					<div>
						昨天看到一篇文章叫浅析为什么SEO是网络营销的最好方式,于是萌发了写这篇文章的想法.因为东莞潮汐SEO认为,SEO不是网络营销,它和竞价一起,并称为SEM,即搜索引擎营销的两种方式.它只是一种辅助手段 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEXG6z.html" rel="bookmark" class="title">正视网站优化：极致的优化是赢得&OpenCurlyDoubleQuote;主动性&rdquo;</a>
					<div>
						一个网站,策划的那天起便与SEO结下了不解之缘,不因别的,只因互联网流量大多都操控在搜索引擎当中.可以说,搜索引擎掌握了网站的生存绝大命脉,因此站长也只能孜孜不倦的踏上了优化之旅.获得了搜索引擎的认可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lpd9rNz.html" rel="bookmark" class="title">冒泡、二分法插入及快速排序算法</a>
					<div>
						1.冒泡排序算法 过程: 1.遍历整个数组,每两两相邻的元素进行比较,如$a[$i]&gt;$a[$i+1]则互换位置,每次比较消除一个逆序. 2.每一次循环后,下次再需要循环的次数减少1. &lt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjZlkp.html" rel="bookmark" class="title">简洁有效的Web服务监控架构图</a>
					<div>
						网站站长们最实用的监控方法 将监控复杂问题,简单化. 背景:源于我想知道几个网站一天24小时,运行的状态,是否都是可以访问状态. 同时能知道服务器有无宕机,不能访问等问题. 同时如果为了这个简单功能去 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6qq3z.html" rel="bookmark" class="title">WPS 2009个人版三大新功能实战评测</a>
					<div>
						金山最近新推出的WPS Office 2009个人版新增多重剪贴板支持:在文件格式上,支持阅读PDF格式.支持UOF格式:还首次提出未来办公的新模式即OaaS(office as a service, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2gGlp.html" rel="bookmark" class="title">MVC模式在j2me项目中的应用&lpar;一&rpar;</a>
					<div>
						版权声明:本文同时发表在www.j2medev.com和我的Blog(blog.csdn.net/alikeboy)上 ,如果需要转载,有三个途径:1)联系我并经我同意:2)和www.j2medev. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3NK6gz.html" rel="bookmark" class="title">解决win7本地连接未识别方法</a>
					<div>
						经常会遇到在家的时候使用WIFI右下角网络连接没问题,但是换到其他地方就出现本地连接未识别状态,下面小编就教大家解决win7本地连接未识别方法,win7系统不同于xp系统,只要它发现没有跟启用协议匹配 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AjOnp.html" rel="bookmark" class="title">Win7屏幕保护设置方法</a>
					<div>
						首先,我们在桌面空白处右键打开菜单,选择 个性化. 然后点击右下角的 屏幕保护程序 然后我们可以看到 屏幕保护程序的窗口了.在下拉菜单中我们可以选择屏幕保护程序的样式 点击 预览,我们可以预览屏幕保护 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0PjxmM.html" rel="bookmark" class="title">WPS设置页码教程</a>
					<div>
						  WPS怎么设置页码?平常写论文或者办公的时候会遇到用WPS设置页码的问题,对一些小白来说可能比较麻烦,下面小编就给大家带来WPS设置页码方法. WPS设置页码 第一步.单击WPS文字的&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZdgq4M.html" rel="bookmark" class="title">如何用后期给花卉增添写意烟缕</a>
					<div>
						  在花卉摄影中,若再增添一缕白烟萦绕,是不是会摆脱平实的画面,从而给画面衬托出多一丝写意?用作品&lt;玉梨魂&gt;作实例,作者花花少在此为如何在梨花上飘出&quot;香魂一缕&quot;的烟雾技 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGXXNp.html" rel="bookmark" class="title">电脑的硬件设备有哪些</a>
					<div>
						  1 键盘鼠标 有线键盘鼠标 键盘鼠标是电脑最基本也是使用频率最高的外设,按照工作方式来区分,有有线跟无线两类. 2 显示器 电脑外部设备,液晶显示器轻巧时尚的外观深受人们的喜爱 显示器是电脑主要的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZggD5b.html" rel="bookmark" class="title">关于自定义sitemapprovider的用法，如何清除生成的目录树？</a>
					<div>
						问题描述 当前的代码可以根据数据库自动生成目录,但是注销登陆后,以其他角色用户登录时,目录没有重新生成,还是第一次登陆时生成的目录,代码中有Clear()函数,但是没起作用,不知道该在什么地方调用.希 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94A5db.html" rel="bookmark" class="title">设计名为MyInteger的类，它包括：</a>
					<div>
						问题描述 设计名为MyInteger的类,它包括:一个名为value的int型数据域,存储这个对象表示的int值.一个为指定的int值创建的MyInteger对象的构造方法.一个返回int的get方法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7PkAM.html" rel="bookmark" class="title">小程序分销商城开发功能</a>
					<div>
						电商小程序,商城小程序,卖货小程序,供应商入驻小程序平台,小程序系统,软件,平台,功能,搭建,开发软件定制开发陈洋150/1315/1740(微/电)     面对互联网浪潮的冲击,我们不畏惧.不退缩 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKn0Xb.html" rel="bookmark" class="title">卡尔曼滤波简介及算法实现代码</a>
					<div>
						卡尔曼滤波器(Kalman Filter)是一个最优化自回归数据处理算法(optimal recursive data processing algorithm).对于解决很大部分的问题,他是最优,效 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7r6Xp.html" rel="bookmark" class="title">梓潼人生活网：服务用户是取胜关键</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 随着互联网高速发展,人们生活已经与 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLKwDM.html" rel="bookmark" class="title">c语言-请问此c程序哪里出错了。。谢谢</a>
					<div>
						问题描述 请问此c程序哪里出错了..谢谢 要求将输入的两个字符串连接起来. #include #include char s1[80],s2[80]; int main() { void f(); p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJXGxp.html" rel="bookmark" class="title">疑惑：如何让自媒体之路更加顺畅高效</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 随着社交产品的发展与成熟,信息的传 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAEe0ZM.html" rel="bookmark" class="title">关于hexo next主题的问题</a>
					<div>
						问题描述 关于hexo next主题的问题 主题的菜单栏显示为此					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7Qkaz.html" rel="bookmark" class="title">菲利普&CenterDot;科特勒博士提出了全新的心灵营销理论</a>
					<div>
						摘要: 3月1日,在孟加拉国首都达卡举办的第一届世界营销峰会(WorldMarketingSummit)上,81岁高龄的现代营销学之父,美国西北大学凯洛格管理学院终身教授菲利普科特勒博士提出了全新的心 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxEWDRp.html" rel="bookmark" class="title">知名实战家话投行十年</a>
					<div>
						文/本刊记者 韩言铭 如今,投行满天飞,在融资会议上,你会碰到印着各种名称的名片跟你交换,问他做什么的,&quot;我们做投行的.&quot;曾几何时,投行还是一个新名词.君不见,一些叫唤着自己做投行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj8xlmp.html" rel="bookmark" class="title">百度排名下降的主要原因分析&lpar;站长必看&rpar;</a>
					<div>
						当搜索引擎的算法改变或者加强时,导致一些网站的某些关键字排名消失,一些管理员就说他们的网站消失了.实际上并非如此,在搜索引擎算法改变或加强时会引起一些页面丢失,或者是过滤.惩罚了某一些页面而不是整个网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvwDJM.html" rel="bookmark" class="title">SQLServer 2005 列所有存储过程的语句&lowbar;mssql2005</a>
					<div>
						为了查找这些存储过程,你可以花时间在互联网搜索,查看一些你还未知道的存储过程,也许在一两个小时您可能会发现你想要...也许你很幸运的找到,其他人在他们的文章中列出所有的存储过程 ,函数和视图,并介绍了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7QKvZM.html" rel="bookmark" class="title">html h p body head-html中如何制作logo？</a>
					<div>
						问题描述 html中如何制作logo? html中设计的时候用css进行布局!但是logo和上面的标题栏怎么分开啊!每次他们都连在一块! 解决方案 用纯css实现的html5 logo标志用纯css实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwyL2vM.html" rel="bookmark" class="title">android-数据接口地址除了聚核还有什么？</a>
					<div>
						问题描述 数据接口地址除了聚核还有什么? 求地址链接,感觉聚核的接口内容太少了,有没有更全面一点的,谢谢 解决方案 APISTORE.http://apistore.baidu.com/					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvWEXrp.html" rel="bookmark" class="title">常用推荐算法</a>
					<div>
						推荐系统的出现 随着互联网的发展,人们正处于一个信息爆炸的时代.相比于过去的信息匮乏,面对现阶段海量的信息数据,对信息的筛选和过滤成为了衡量一个系统好坏的重要指标.一个具有良好用户体验的系统,会将海量 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlAk5np.html" rel="bookmark" class="title">证券投资咨询公司十大骗术</a>
					<div>
						一.老乡型.从你打进免费咨询电话或热线电话,听出你的口音,然后这些助理立即变换口音,和你套近乎,拉老乡. 二.诱利型.每个人到了股市都是为利而来,利用人性贪婪暴富的心理,利用收益率,诱骗你入会. 三. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWd91jp.html" rel="bookmark" class="title">写给认真学习却进步缓慢的大一学生</a>
					<div>
						周二最后一堂课,安排了一次班内的编程小PK.四道题,90分钟.一名同学33分钟内完成,8名同学提交了3道,17名同学提交两道,23名同学提交了一道,其中有12名同学另一一题尝试着提交,但没有成功. 不 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
